/**********************************************************************
*  2011 Microchip Technology Inc.
*
* FileName:        advolts.c
* Dependencies:    Header (.h) files if applicable, see below
* Processor:       dsPIC33Exxxx
* Compiler:        MPLAB C30 v3.30 or higher
*
* SOFTWARE LICENSE AGREEMENT:
* Microchip Technology Incorporated ("Microchip") retains all ownership and 
* intellectual property rights in the code accompanying this message and in all 
* derivatives hereto.  You may use this code, and any derivatives created by 
* any person or entity by or on your behalf, exclusively with Microchip's
* proprietary products.  Your acceptance and/or use of this code constitutes 
* agreement to the terms and conditions of this notice.
*
* CODE ACCOMPANYING THIS MESSAGE IS SUPPLIED BY MICROCHIP "AS IS".  NO 
* WARRANTIES, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED 
* TO, IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY AND FITNESS FOR A 
* PARTICULAR PURPOSE APPLY TO THIS CODE, ITS INTERACTION WITH MICROCHIP'S 
* PRODUCTS, COMBINATION WITH ANY OTHER PRODUCTS, OR USE IN ANY APPLICATION. 
*
* YOU ACKNOWLEDGE AND AGREE THAT, IN NO EVENT, SHALL MICROCHIP BE LIABLE, WHETHER 
* IN CONTRACT, WARRANTY, TORT (INCLUDING NEGLIGENCE OR BREACH OF STATUTORY DUTY), 
* STRICT LIABILITY, INDEMNITY, CONTRIBUTION, OR OTHERWISE, FOR ANY INDIRECT, SPECIAL, 
* PUNITIVE, EXEMPLARY, INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, FOR COST OR EXPENSE OF 
* ANY KIND WHATSOEVER RELATED TO THE CODE, HOWSOEVER CAUSED, EVEN IF MICROCHIP HAS BEEN 
* ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE.  TO THE FULLEST EXTENT 
* ALLOWABLE BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS IN ANY WAY RELATED TO 
* THIS CODE, SHALL NOT EXCEED THE PRICE YOU PAID DIRECTLY TO MICROCHIP SPECIFICALLY TO 
* HAVE THIS CODE DEVELOPED.
*
* You agree that you are solely responsible for testing the code and 
* determining its suitability.  Microchip has no obligation to modify, test, 
* certify, or support the code.
*
* REVISION HISTORY:
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
* Date      Comments on this revision
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
* 06/02/11	Initial Release for dsPIC33E
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*
* ADDITIONAL NOTES:
*
*
**********************************************************************/
volatile unsigned char adones;
volatile unsigned char adtens;
volatile unsigned char adhunds;
volatile unsigned char adthous;
 
/*---------------------------------------------------------------------
  Function Name: advolt
  Description:   Convert Raw ADC data to volts for LCD display
  Inputs:        Raw ADC data 
  Returns:       None
-----------------------------------------------------------------------*/
void advolt( unsigned int adc_conv_data )
{
 adones = 0;					    // reset values
 adtens = 0;
 adhunds = 0;
 adthous = 0;
 
 while ( adc_conv_data > 0 )
 {
  	if( adc_conv_data > 1241 )		//test for 1 volt or greater
	{
		adones++;			        //increment 1 volt counter
		adc_conv_data -= 1242;		//subtract 1 volt
	}
	
	else if( adc_conv_data > 124 )	//test for 0.1 volt	
	{
		if ( adtens < 9 )
		{
		  adtens++;			//increment tenths
		}
		else 
		{
		  adones++;			//tenths has rolled over
		  adtens = 0;		//so increment ones and reset tenths
		}

		adc_conv_data -= 125;        //test for 0.01 volt
	}

	else if( adc_conv_data > 12 )		
	{
		adhunds++;			//increment hundreths
		adc_conv_data -= 13;
	}
 
	else if ( adc_conv_data <= 12 )
	{
		adthous++;
		adc_conv_data --;
	}
 }

	adones += 0x30;				
 	adtens += 0x30;
 	adhunds += 0x30;
	adthous += 0x30;
} 


